/*****************************************************************************
**  Copyright (C) 2004                                                      **
**  University of Tennessee                                                 **
**                                                                          **
**  See the file COPYRIGHT in the package base directory for details        **
*****************************************************************************/

#ifndef _CALLGRAPH_H
#define _CALLGRAPH_H   

/*
 *----------------------------------------------------------------------------
 *
 * class Callgraph
 *
 *----------------------------------------------------------------------------
 */

#include <iostream>
  using std::ostream;
  using std::endl;

#include <vector>
  using std::vector;

#include <map>
using std::map;

#include "Cnode.h"
#include "Executable.h"


class Callgraph
{
 public:
  
  // constructor and destructor
 
   Callgraph(Executable& exec, string mainfun);
  ~Callgraph();

  int    get_num_nodes() const { return nodev.size(); }
  Cnode* get_root()      const { return nodev[0]; } 
  Cnode* get_node(int i) const { return nodev[i]; }
  void   insert_prev_level(Cnode*) ; 
  void   empty_prev_level() ; 
  void   insert_next_level(Cnode*)  ;      
  bool   prev_level_unexpandable() const ;

 private:

  vector<Cnode*> nodev;
  vector<Cnode*> prev_level;
  vector<Cnode*> next_level ;  
  Executable&  exec;
};

ostream& operator<<(ostream& out, const Callgraph& cgraph); 

#endif














