/****************************************************************************
**  Copyright (C) 2004                                                     **
**  University of Tennessee                                                **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#include "Callsite.h"
#include "Function.h"
#include "Module.h"
#include "Cnode.h"

struct Callsite;


ostream& operator<<(ostream& out, const Callsite& csite)
{
  out << "CALLSITE" << " "
      << csite.id << " " 
      << csite.index<<" "
      << csite.mod->id << " " 
      << csite.line << " " 
      << csite.caller->id << " "
      << csite.callee->id << " "
      << csite.cnodev.size() << " ";  
   

   for ( int i = 0; i < csite.cnodev.size() ; i++ )
     out << " " << csite.cnodev[i]->get_id();

  out << endl ; 

  return out;
}
