/*****************************************************************************
**  Copyright (C) 2004                                                      **
**  University of Tennessee                                                 **
**                                                                          **
**  See the file COPYRIGHT in the package base directory for details        **
******************************************************************************/

#ifndef _CNODE_H
#define _CNODE_H   

/*
 *----------------------------------------------------------------------------
 *
 * struct Cnode
 *
 *----------------------------------------------------------------------------
 */

#include <iostream>
  using std::ostream;
  using std::endl;

#include <string>
  using std::string;

#include <vector>
  using std::vector;

#include <dpcl.h>
#include "Function.h"
#include "Callsite.h"

struct Callsite ;

class Cnode
{ 
 public: 
  
  // constructor and destructor 
 
   Cnode(int id, Callsite* csite_ptr , Cnode* parent) ;
   ~Cnode();

  void add_child(Cnode* child) { childv.push_back(child); }  

  int  get_id() const { return id ; } 

  int  get_csite_ptr_id() const  
    {
      if ( csite_ptr != NULL)
        return csite_ptr->id ;
      else
        return -1; 
    }

  int  get_num_cnodes() const { return childv.size(); }
  
  int  get_parent_id()  const 
    {
      if ( parent != NULL)
        return parent->id ;
      else 
        return -1 ; 
    }
  

  Callsite* get_csite_ptr() const  { return csite_ptr ; } 
   
  Cnode*  get_parent() const { return parent ; }

  int get_childv_size() const { return childv.size() ; } 
  
  int get_child_id(int i) const { return childv[i]->id ; } 

 private: 

  int                 id;
  Callsite*           csite_ptr;
  Cnode*              parent ;
  vector<Cnode*>      childv;
};

ostream& operator<<(ostream& out, const Cnode& cnode); 

#endif





