/****************************************************************************
**  Copyright (C) 2004                                                     **
**  University of Tennessee                                                **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef _CONE_CNDATA_H
#define _CONE_CNDATA_H

#include "cone_metv.h" 
#include <stdio.h>

struct cone_cndata;

struct cone_cndata* cone_cndata_create(int cnode_id);
void                cone_cndata_delete(struct cone_cndata* cndata);
void                cone_cndata_enter(struct cone_cndata* cndata, 
				      struct cone_metv* metv); 
void                cone_cndata_exit(struct cone_cndata* cndata, 
				     struct cone_metv* metv); 
int                 cone_cndata_cnode_id(struct cone_cndata* cndata);
unsigned long long  cone_cndata_get_metvalue(struct cone_cndata* cndata, 
					     int i);
void                cone_cndata_fprintf(FILE* stream, 
					struct cone_cndata* cndata);
int                 cone_cndata_num_stdmets();
void                cone_cndata_fprintf_stdmets(FILE* stream);

#endif

