/****************************************************************************
**  Copyright (C) 2004                                                     **
**  University of Tennessee                                                **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef _CONE_CNODE_H
#define _CONE_CNODE_H

#include <stdio.h>
#include "cone_cndata.h"

struct cone_cnode;


struct cone_cnode*  cone_cnode_create(char* cnode_spec);
void                cone_cnode_delete(struct cone_cnode* cnode);

long                cone_cnode_id(struct cone_cnode* cnode);
long                cone_cnode_csite_id( struct cone_cnode* cnode);
long                cone_cnode_parent_id(struct cone_cnode* cnode);
long                cone_cnode_num_childs(struct cone_cnode* cnode);
long                cone_cnode_child_id(struct cone_cnode* cnode, long i);

struct cone_cndata* cone_cnode_get_data(struct cone_cnode* cnode );

void                cone_cnode_set_data(struct cone_cnode* cnode,struct cone_cndata* temp);
long                cone_cnode_get_tag(struct cone_cnode* cnode);
void                cone_cnode_set_tag(struct cone_cnode* cnode, long tag);

void                cone_cnode_fprintf(FILE* stream, struct cone_cnode* cnode);

#endif
