/****************************************************************************
**  Copyright (C) 2004                                                     **
**  University of Tennessee                                                **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef _CONE_FUNC_H
#define _CONE_FUNC_H

#include <stdio.h>

struct cone_func;

struct cone_func* cone_func_create(char* func_spec);
void              cone_func_delete(struct cone_func* func);

long              cone_func_id(struct cone_func* func);
const char*       cone_func_name(struct cone_func* func);
long              cone_func_begln(struct cone_func* func);
long              cone_func_endl(struct cone_func* func);
long              cone_func_mod_id(struct cone_func* func);
long              cone_func_num_csites(struct cone_func* func);
long              cone_func_csite_id(struct cone_func* func, long i);

long              cone_func_get_tag(struct cone_func* func);
void              cone_func_set_tag(struct cone_func* func, long tag);

void              cone_func_fprintf(FILE* stream, struct cone_func* func);

#endif
