/****************************************************************************
**  Copyright (C) 2004                                                     **
**  University of Tennessee                                                **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef _CONE_MOD_H
#define _CONE_MOD_H

#include <stdio.h>

struct cone_mod;

struct cone_mod* cone_mod_create(char* mod_spec);
void             cone_mod_delete(struct cone_mod* mod);

long             cone_mod_id(struct cone_mod* mod);
const char*      cone_mod_name(struct cone_mod* mod);
long             cone_mod_num_funcs(struct cone_mod* mod);
long             cone_mod_func_id(struct cone_mod* mod, long i);

void             cone_mod_set_tag(struct cone_mod* mod, long tag);
long             cone_mod_get_tag(struct cone_mod* mod);

void             cone_mod_fprintf(FILE* stream, struct cone_mod* mod);

#endif
