/****************************************************************************
**  Copyright (C) 2004                                                     **
**  University of Tennessee                                                **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef _CONE_PROG_H
#define _CONE_PROG_H

#include <stdio.h>

#include "cone_mod.h"
#include "cone_func.h"
#include "cone_csite.h"
#include "cone_cnode.h"


struct cone_prog
{
  char*  name;
  long   nmods;
  long   nfuncs;
  long   ncsites;
  long   ncnodes; 
  struct cone_mod**   modv;
  struct cone_func**  funcv;
  struct cone_csite** csitev;
  struct cone_cnode** cnodev ; 
};

struct cone_prog*  cone_prog_create(const char* path);
void               cone_prog_delete(struct cone_prog* prog);

const char*        cone_prog_name(struct cone_prog* prog);

long               cone_prog_num_mods(struct cone_prog* prog);
long               cone_prog_num_funcs(struct cone_prog* prog);
long               cone_prog_num_csites(struct cone_prog* prog);
long               cone_prog_num_cnodes(struct cone_prog* prog);

struct cone_mod*   cone_prog_mod(struct cone_prog* prog, long i);
struct cone_func*  cone_prog_func(struct cone_prog* prog, long i);
struct cone_csite* cone_prog_csite(struct cone_prog* prog, long i);
struct cone_cnode* cone_prog_cnode(struct cone_prog* prog, long i);

void               cone_prog_fprintf(FILE* stream, struct cone_prog* prog);

#endif


